#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <gamecms5>

#define TIMEDELAY		15							//     
#define WIN_KOEF		1.5							//    
#define MIN_PLAYER		1							//  ,    

// 
new const gBetsNum[] = { 1, 2, 3, }

#define SetBit(%0,%1) 				((%0) |= (1 << (%1)))
#define ClearBit(%0,%1) 			((%0) &= ~(1 << (%1)))
#define IsSetBit(%0,%1) 			((%0) & (1 << (%1)))
#define IsNotSetBit(%0,%1) 			(~(%0) & (1 << (%1)))
#define InvertBit(%0,%1) 			((%0) ^= (1 << (%1)))

#define CS_TEAM_SPECTATOR 3 // 1-terrorist,2-, 3-,0-

new g_iBitUserConnected; //     is_user_connected

new g_iMaxPlayers
new g_iBetStart
new g_iBetOpponent[ 2 ]
new g_iBetOpponentName[ 2 ][ 32 ]

new g_iBetDelay

new iPlayerBet[ 33 ]
new iPlayerBetTeam[ 33 ]
new Float:fPlayerBetTemp[ 33 ]

public plugin_init()
{
	register_plugin("[GameCMS] Real Money Rates","1.1","InKay")

	// Event 
	register_event("HLTV", "Event_RoundStart", "a", "1=0", "2=0")

	// Ham 
	RegisterHam(Ham_Killed, "player", "HamKilled_Pre", 0)

	// 
	register_menucmd( register_menuid( "Show_BetMenu" ), (1<<0 | 1<<1 | 1<<2 | 1<<3), "Handler_BetMenu")
	
	//  
	register_clcmd("say /betss","Show_BetMenu")
	
	// 
	register_dictionary("bets_gamecms.txt")

	//
	g_iMaxPlayers = get_maxplayers()
}

/*==========================================
	 
===========================================*/

public client_putinserver( id )
	ClearBit( g_iBitUserConnected, id );
	
public client_disconnect(id)
{
	SetBit( g_iBitUserConnected, id );
	g_iBetStart = false
	g_iBetDelay = 0

	if(g_iBetOpponent[0] == id || g_iBetOpponent[1] == id)
	{
		for(new i = 1; i <= g_iMaxPlayers; i++)
		{
			if(fPlayerBetTemp[i])
				cmsapi_set_user_money(i, (cmsapi_get_user_money(i) + fPlayerBetTemp[i]))

			iPlayerBet[i] = 0
			iPlayerBetTeam[i] = 0
			fPlayerBetTemp[i] = 0.0
		}
	}
}

/*==========================================
	   
===========================================*/

public Event_RoundStart()
{
	g_iBetStart = false
	g_iBetDelay = 0

	remove_task(100500)

	for(new i = 1; i <= g_iMaxPlayers; i++)
	{
		if( IsNotSetBit( g_iBitUserConnected, i ) )
			continue

		iPlayerBet[i] = 0
		iPlayerBetTeam[i] = 0
		fPlayerBetTemp[i] = 0.0
	}
}

/*==========================================
	  
===========================================*/

public HamKilled_Pre(iVictim, iAttacker, iCourse)
{
	if(g_iBetStart)
	{
		if(g_iBetOpponent[0] == iVictim)
		{
			g_iBetStart = false
			g_iBetDelay = 0

			BetWin(2)
		}
		else
		if(g_iBetOpponent[1] == iVictim)
		{
			g_iBetStart = false
			g_iBetDelay = 0

			BetWin(1)
		}
		return HAM_IGNORED
	}

	CheckBet(0)
	return HAM_IGNORED
}

/*==========================================
	  
===========================================*/

public DelayBetMenu()
{
	for(new i = 1; i <= g_iMaxPlayers; i++)
	{
		if( IsNotSetBit( g_iBitUserConnected, i ) || is_user_alive(i))
			continue

		if(cs_get_user_team(i) == CS_TEAM_SPECTATOR)
			continue

		if(!cmsapi_is_user_member(i))
			continue

		if(g_iBetOpponent[0] == i || g_iBetOpponent[1] == i)
			continue

		if(iPlayerBetTeam[i])
			continue

		if(g_iBetDelay <= 0)
			show_menu(i, 0, "^n", 1)
		else
			Show_BetMenu(i)
	}

	g_iBetDelay -= 1
	if(g_iBetDelay <= 0)
	{
		remove_task(100500)
	}
}

/*==========================================
	 
===========================================*/

public Show_BetMenu(id)
{
	if(iPlayerBetTeam[id])
		return PLUGIN_HANDLED

	new szText[256]
	new iLen

	iLen += formatex(szText[iLen], charsmax( szText ) - iLen, "%L", LANG_PLAYER, "MB_BETMENU_TITLE", cmsapi_get_user_money(id))

	iLen += formatex(szText[iLen], charsmax( szText ) - iLen, "\r1. \w%L", LANG_PLAYER, "MB_BETMENU_ITEMS", g_iBetOpponentName[0])
	iLen += formatex(szText[iLen], charsmax( szText ) - iLen, "\r2. \w%L^n", LANG_PLAYER, "MB_BETMENU_ITEMS", g_iBetOpponentName[1])
	iLen += formatex(szText[iLen], charsmax( szText ) - iLen, "\r3. \w%L^n^n%s", LANG_PLAYER, "MB_BETMENU_ITEM_3", ConvertBet(1, iPlayerBet[id]), ShowTime()) 

	show_menu(id, (1<<0 | 1<<1 | 1<<2 | 1<<3), szText, -1, "Show_BetMenu")
	return PLUGIN_HANDLED
}

/*==========================================
	 ()
===========================================*/

public Handler_BetMenu(id, iKey)
{
	new szName[32]
	get_user_name(id, szName, charsmax( szName ))

	switch( iKey )
	{
		case 0:
		{
			new Float:fBet = float(gBetsNum[iPlayerBet[id]]) / 100.0
			if(cmsapi_get_user_money(id) < fBet)
			{
				UTIL_SayText(0, "%L", LANG_PLAYER, "MB_BET_NOMONEY")

				Show_BetMenu(id)
				return PLUGIN_HANDLED
			}

			cmsapi_set_user_money(id, (cmsapi_get_user_money(id) - fBet))
			fPlayerBetTemp[id] = fBet

			iPlayerBetTeam[id] = 1
			UTIL_SayText(0, "%L", LANG_PLAYER, "MB_BET_GOOD", szName, ConvertBet(2, iPlayerBet[id]), g_iBetOpponentName[0])
		}
	
		case 1:
		{
			new Float:fBet = float(gBetsNum[iPlayerBet[id]]) / 100.0
			if(cmsapi_get_user_money(id) < fBet)
			{
				UTIL_SayText(0, "%L", LANG_PLAYER, "MB_BET_NOMONEY")

				Show_BetMenu(id)
				return PLUGIN_HANDLED
			}

			cmsapi_set_user_money(id, (cmsapi_get_user_money(id) - fBet))
			fPlayerBetTemp[id] = fBet

			iPlayerBetTeam[id] = 2
			UTIL_SayText(0, "%L", LANG_PLAYER, "MB_BET_GOOD", szName, ConvertBet(2, iPlayerBet[id]), g_iBetOpponentName[1])
		}
	
		case 2:
		{
			iPlayerBet[id] += 1
			if(iPlayerBet[id] >= sizeof( gBetsNum ))
				iPlayerBet[id] = 0

			Show_BetMenu(id)
		}
	}
	return PLUGIN_HANDLED
}

/*==========================================
	  
===========================================*/

stock CheckBet(iType)
{
	if(GetPlayerNum() < MIN_PLAYER)
		return false
	
	new iNum[2]
	
	for( new pId = 1; pId <= g_iMaxPlayers; pId++ )
	{
		if( is_user_alive( pId ) )
		{
			if( cs_get_user_team( pId ) == 1 )
				if( ++iNum[ 0 ] > 1 )
				{
					g_iBetOpponent[0]=0;
					g_iBetOpponent[1]=0;
					return false;
				}
				else g_iBetOpponent[ 0 ] = pId;
			
			if( cs_get_user_team( pId ) == 2 )
				if( ++iNum[ 1 ] > 1 )
				{
					g_iBetOpponent[0]=0;
					g_iBetOpponent[1]=0;
					return false;
				}
				else g_iBetOpponent[ 1 ] = pId;
		}	
	}

	if(!iType)
	{
		g_iBetStart = true
		
		get_user_name(g_iBetOpponent[0], g_iBetOpponentName[0], charsmax( g_iBetOpponentName[] ))
		get_user_name(g_iBetOpponent[1], g_iBetOpponentName[1], charsmax( g_iBetOpponentName[] ))

		g_iBetDelay = TIMEDELAY
		set_task(1.0, "DelayBetMenu", 100500, _, _, "b")
	}
	return true
}

/*==========================================
	 ,  
===========================================*/

stock BetWin(iTeam)
{
	for(new i = 1; i <= g_iMaxPlayers; i++)
	{
		if( IsNotSetBit( g_iBitUserConnected, i ) )
			continue

		if(iPlayerBetTeam[i] <= 0)
			continue

		if(iPlayerBetTeam[i] != iTeam)
		{
			UTIL_SayText(i, "%L", LANG_PLAYER, "MB_BET_LOSE", gBetsNum[iPlayerBet[i]]) 

			iPlayerBet[i] = 0
			iPlayerBetTeam[i] = -1
			fPlayerBetTemp[i] = 0.0

			continue
		}

		fPlayerBetTemp[i] *= WIN_KOEF
		cmsapi_set_user_money(i, (cmsapi_get_user_money(i) + fPlayerBetTemp[i]))

		UTIL_SayText(i, "%L", LANG_PLAYER, "MB_BET_WIN", fPlayerBetTemp[i]) 

		iPlayerBet[i] = 0
		iPlayerBetTeam[i] = -1
		fPlayerBetTemp[i] = 0.0
	}
}

/*==========================================
	 
===========================================*/

stock ConvertBet(iType, iBet)
{
	new szTemp[64]
	new iTemp[2]

	if(gBetsNum[iBet] >= 100)
	{
		iTemp[0] = gBetsNum[iBet] / 100
		iTemp[1] = gBetsNum[iBet] - (iTemp[0] * 100)

		if(iTemp[1])
		{
			if(iType == 1)
				formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_1_RK", iTemp[0], iTemp[1])
			else
				formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_2_RK", iTemp[0], iTemp[1])
		}else{
			if(iType == 1)
				formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_1_R", iTemp[0])
			else
				formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_2_R", iTemp[0])
		}
	}else{
		if(iType == 1)
			formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_1_K", gBetsNum[iBet])
		else
			formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_2_K", gBetsNum[iBet])
	}
	return szTemp
}

/*==========================================
	 
===========================================*/

stock ShowTime()
{
	new szTemp[64]
	formatex(szTemp, charsmax( szTemp ), "%L", LANG_PLAYER, "MB_BETMENU_SHOWTIME", g_iBetDelay)

	return szTemp
}

/*==========================================
	 - 
===========================================*/

stock GetPlayerNum()
{
	new iNum

	for(new i = 1; i <= g_iMaxPlayers; i++)
	{
		if( IsNotSetBit( g_iBitUserConnected, i ) )
			continue

		if(cs_get_user_team(i) == CS_TEAM_SPECTATOR)
			continue

		iNum += 1
	}
	return iNum
}

/*==========================================
	Fakemeta
===========================================*/

stock cs_get_user_team( pId )
	return get_pdata_int( pId, 114, 5 );

stock UTIL_SayText(pPlayer, const szMessage[], any:...)
{
	new szBuffer[190], iLen = format(szBuffer, charsmax(szBuffer), "%L ", LANG_PLAYER, "MB_BET_CHAT_PREFIX");
	
	if(numargs() > 2) vformat(szBuffer[iLen], charsmax(szBuffer), szMessage, 3);
	else copy(szBuffer[iLen], charsmax(szBuffer), szMessage);
	
	while(replace(szBuffer, charsmax(szBuffer), "!y", "^1")) { }
	while(replace(szBuffer, charsmax(szBuffer), "!t", "^3")) { }
	while(replace(szBuffer, charsmax(szBuffer), "!g", "^4")) { }
	
	switch(pPlayer)
	{
		case 0:
		{
			for(new iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++)
			{
				if( IsNotSetBit( g_iBitUserConnected, iPlayer ) ) continue;
				engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, 76, {0.0, 0.0, 0.0}, iPlayer);
				write_byte(iPlayer);
				write_string(szBuffer);
				message_end();
			}
		}
		default:
		{
			engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, 76, {0.0, 0.0, 0.0}, pPlayer);
			write_byte(pPlayer);
			write_string(szBuffer);
			message_end();
		}
	}
}